#include <stdlib.h>
#include <stdio.h>
#include "wirp.h"

#ifdef VGA
#define msw_rgb vga_rgb
#endif

#define Min(a,b) ((a)<(b) ? (a):(b))
#define Abs(x)   ((x)<0 ? -(x):(x))
#pragma pack(2)
typedef unsigned short UINT;
typedef          short WORD;
typedef          long  DWORD;
typedef          long  LONG;
typedef struct tagBITMAPFILEHEADER
{
    UINT    bfType;
    DWORD   bfSize;
    UINT    bfReserved1;
    UINT    bfReserved2;
    DWORD   bfOffBits;
} BITMAPFILEHEADER;
typedef struct tagBITMAPINFOHEADER
{
    DWORD   biSize;
    LONG    biWidth;
    LONG    biHeight;
    WORD    biPlanes;
    WORD    biBitCount;
    DWORD   biCompression;
    DWORD   biSizeImage;
    LONG    biXPelsPerMeter;
    LONG    biYPelsPerMeter;
    DWORD   biClrUsed;
    DWORD   biClrImportant;
} BITMAPINFOHEADER;

/*fct w_readbmp */
Pixel * w_readbmp(char *file,int *wp,int *hp,int *maxpalp
         ,unsigned char *palr,unsigned char *palg,unsigned char *palb) {
 BITMAPFILEHEADER bmfh;
 BITMAPINFOHEADER bmih;
 FILE *fbm;
 int i,w,h,npix,maxpal;
 Pixel *bm,*b1;
 unsigned char palby[4],palum[256];
 if ((fbm=fopen(file,"rb"))==NULL) return NULL;
 fread(&bmfh,sizeof(bmfh),1,fbm);
 if (bmfh.bfType!=0x4d42)          return NULL;
 fread(&bmih,sizeof(bmih),1,fbm);
 maxpal=(bmfh.bfOffBits - bmih.biSize - 14) / 4;
 printf("bfOffBits %d  biSize %d pal %d\n",bmfh.bfOffBits,bmih.biSize,maxpal);
 if (maxpal>*maxpalp) maxpal=*maxpalp;
 *maxpalp=maxpal;
 fseek(fbm, bmih.biSize + 14,SEEK_SET);
 for (i=0;i<256;i++) palum[i]=0;
 for (i=0;i<maxpal;i++) {
  fread(palby,4,1,fbm);
  if (palb) {
   palr[i]=palby[2];
   palg[i]=palby[1];
   palb[i]=palby[0];
  } else {
   int r=palby[2],g=palby[1],b=palby[0],j,id,im=32000,ix=0;
   printf(" r%d g%d b%d ",r,g,b);
   for (j=0;j<16;j++) {
    int rp=(msw_rgb[j]&0xff)<<0,gp=((msw_rgb[j]>>8)&0xff)<<0,bp=((msw_rgb[j]>>16)&0xff)<<0;
    if ((id=Abs(rp-r)*r+Abs(gp-g)*g+Abs(bp-b)*b) < im) { im=id;ix=j; }
   }
   palum[i]=ix;
   printf(" palum%d ",ix);
  }
 }
 printf("\nw %d h %d planes %d bits %d compr %d\n",
    (int)bmih.biWidth,(int)bmih.biHeight,(int)bmih.biPlanes,
    (int)bmih.biBitCount,(int)bmih.biCompression); 
 if (bmih.biPlanes     !=1
  ||(bmih.biBitCount!=8&&bmih.biBitCount!=4)
  || bmih.biCompression!=0) return NULL;
 fseek(fbm, bmfh.bfOffBits,SEEK_SET);
 w=bmih.biWidth,h=bmih.biHeight;
 npix=w*h;
 if ((bm=malloc(npix))==NULL) return NULL;
 if (bmih.biBitCount==4) {
  unsigned char *bz;
  int j,w1=(w+1)/2,w2=w1-w1%2;
  if ((bz=malloc(w1))!=NULL) { 
   for (i=1;i<=h;i++) {
    if (fread(bz,w1,1,fbm)!=1) { free(bm); return NULL; }
    if (w1%4) fread(palby,4-(w1%4),1,fbm);
    b1=bm+(h-i)*w;
    for (j=0;j<w2;j++) {
     register int b=bz[j];
     *b1++=b>>4;
     *b1++=b&0xf;
    }
    if (w1!=w2) *b1++=bz[w2]>>4;
   }
   free(bz);
  }
 } else {
  for (i=1;i<=h;i++) {
   if (fread(bm+(h-i)*w,w,1,fbm)!=1) { free(bm); return NULL; }
   if (w%4) fread(palby,4-(w%4),1,fbm);
  }
 }
 fclose(fbm);
 /*     printf("npix %d w %d h %d\n",npix,w,h); */
 if (!palb) for (i=0;i<w*h;i++) bm[i]=palum[bm[i]];
 *wp=w;*hp=h;
 return bm;
}

/*fct w_bmpred */
Pixel * w_bmpred(Pixel *b0,int wp,int hp) {
 int w=wp/2,h=hp/2,npix=w*h;
 int i,j;
 Pixel *bm,*b;
 if ((bm=malloc(npix))!=NULL) {
  b=bm;
  for (i=0;i<h;i++) {
   for (j=0;j<w;j++) {
    *b++=*b0;
    b0+=2;
   }
   b0+=wp+(wp%2);
  }
 }
 return bm;
}
/*fct w_bmpblow */
Pixel * w_bmpblow(Pixel *b0,int wp,int hp,int winc) {
 int w=wp*2,h=hp*2,npix=w*h;
 int i,j;
 Pixel *bm,*b;
 if ((bm=malloc(npix))!=NULL) {
  b=bm;
  for (i=0;i<hp;i++) {
   for (j=0;j<wp;j++) {
    register Pixel c=*b0++;
    *b=c;
    *(b+w)=c;
    *(++b)=c;
    *(b+w)=c;
    b++;
   }
   b0+=winc-wp;
   b+=w;
  }
 }
 return bm;
}
/*        
main(int argc,char **argv) {
 int m,x,y,x0=0,y0=0,xl=-1,yl,i,w,h,wb,hb,npix,maxpal=256;
 Pixel *bm,*b1,*b2,*b3,*bb;
 unsigned char palr[255],palg[255],palb[255];
 char c;
 vga_init();
 bm=vga_readbmp(argv[1],&w,&h,&maxpal,palr,palg,palb);
 getchar();
 if (!bm) exit(1);
 if (maxpal>16) w_setpal(palr,palg,palb);
 b1=w_bmpred(bm,w,h);
 b2=w_bmpred(b1,w/2,h/2);
 b3=w_bmpred(b2,w/4,h/4);
 wb=Min(w,vga_mx);
 hb=Min(h,vga_my);
 bb=w_bmpblow(bm,wb,hb,w);
 wb*=2,hb*=2;
 do {
  int mw=w<vga_mx ? w : vga_mx;
  int mh=h<vga_my ? h : vga_my;
  m=vga_getmes(&x,&y);
// m=getch();
  switch (m) {
   case '1': vga_putbox(0,0,w/2   ,h/2   ,b1); break;
   case '2': vga_putbox(0,0,w/4   ,h/4   ,b2); break;
   case '3': vga_putbox(0,0,w/8   ,h/8   ,b3); break;
   case '0': vga_putbox(0,0,w     ,h     ,bm); break;
   case 'b': vga_putbox(0,0,wb    ,hb    ,bb); break;
   case 'h': x0-=20; vga_putbox(x0,y0,w     ,h     ,bm); break;
   case 'l': x0+=20; vga_putbox(x0,y0,w     ,h     ,bm); break;
   case 'j': y0-=20; vga_putbox(x0,y0,w     ,h     ,bm); break;
   case 'k': y0+=20; vga_putbox(x0,y0,w     ,h     ,bm); break;
   case 0  : break;
   default:
    vga_setcur(0);
    vga_wartsync(1);
    if (yl>=0)
    vga_putbox(x,y,w     ,h     ,bm);
    xl=x;yl=y;
  }
 } while (m!='q');
 vga_enit();
}
*/
