/* wirprsci, Windows apI Replacement Project ReSourCe Includer /ak 970213

 wirprsci in.rsc in.c out.rsc out.c

   replaces resource strings from in.rsc in in.c, result is out.c
   out.rsc will contain all resource strings not found in in.c

   Returns:  3 if Error (file not found, etc.)
             2 if no replacements
             1 if not all replaced
             0 if all replaced
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define mzl 2000 /* max n.o. lines in in.rsc */
#define mz 200   /* max linelength in in.rsc, in.c */
static char *zl[mzl],zv[mzl];

int main(int argc,char **argv) {
 int nzl=0,ver=0;
 int n,iz,i;
 char *cp,z[mz],name[20];
 FILE *fri,*fci,*fro,*fco;
 if (argc!=5) {printf("Usage: wirprsci in.rsc in.c out.rsc out.c\n"); exit(3);}
 if ((fri=fopen(argv[1],"r"))==NULL) 
  { printf("could not open:%s\n",argv[1]); exit(3); }
 if ((fci=fopen(argv[2],"r"))==NULL) 
  { printf("could not open:%s\n",argv[2]); exit(3); }
 if ((fro=fopen(argv[3],"w"))==NULL) 
  { printf("could not open:%s\n",argv[3]); exit(3); }
 if ((fco=fopen(argv[4],"w"))==NULL) 
  { printf("could not open:%s\n",argv[4]); exit(3); }
 
 while (nzl<mzl) {
  fgets(z,mz,fri); if (feof(fri)) break;
  n=strlen(z);
  if ((cp=malloc(n+1))==NULL) { printf("Insufficient memory\n"); exit(3); }
  strcpy(cp,z);
  zl[nzl]=cp; zv[nzl++]=0;
 }
 if (nzl>=mzl && !feof(fri)) {printf("> %d lines on %s\n",mzl,argv[1]);exit(3);}
 fclose(fri);

 while (1) {
  fgets(z,mz,fci); if (feof(fci)) break;
  if ((cp=strchr(z,'"'))!=NULL) {
   for (iz=0;iz<nzl;iz++) if (!zv[iz]) {
    char *cn,*cz=zl[iz];
    char *ck=strchr(cz,',');
    if (ck) {
     n=ck-cz; strncpy(name,cz,n); name[n]=0;
     if (!strncmp(cp+1,cz,n) && (*(cp+n+1)==',' || *(cp+n+1)=='"')) {
      char zn[mz*2];
      strncpy(zn,z,(cp-z)+1); zn[(cp-z)+1]=0;
      strcat(zn,cz);
      cn=strstr(zn,"\n"); if (cn) *cn=0;
      if ((ck=strchr(cp+1,'"'))!=NULL) {
       zv[iz]=1;ver++;
       if (strstr(zn,"bitmap") && zl[iz+1][0]=='(') {
        strcat(zn,"\",\n");
        fputs(zn,fco);
        while (++iz<nzl) {
         zv[iz]=1;ver++;
         strcpy(zn,"  \"");
         strcat(zn,zl[iz]+1);
         cn=strchr(zn,')');if (!cn) cn=strchr(zn,'\n');
         *cn++='"'; *cn++='\n'; *cn=0;
         fputs(zn,fco);
         if (strchr(zl[iz],')')) break;
        }
        for (i=0;i<2;) {
         if ((ck=strchr(ck,','))==NULL) {
          ck=fgets(z,mz,fci);
          if ((cn=strchr(ck,','))!=NULL) { ck=cn+1; i++; }
         } else { ck++;i++; }
        }
        ck--; strcpy(zn,"   ");
       }
       strcat(zn,ck);
       fputs(zn,fco);
       goto l1;
      }
     }
    }
   }
  }
  fputs(z,fco);
l1:;
 }

 for (iz=0;iz<nzl;iz++) if (!zv[iz]) fputs(zl[iz],fro);

 printf("%d lines replaced in %s, %d lines remaining in %s\n",
         ver,          argv[4],nzl-ver,              argv[3]);
 return ver==0 ? 2 : (ver==nzl ? 0 : 1);
}




