
/*#define B16   // fuer 16bit
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wirp.h"
#ifdef B16
 #define HP huge
 unsigned char far *glmalloc(long n) ;
 void glfree(unsigned char far *p) ;
 void glmemset(unsigned char huge *pm,int b,long n) {
  while (n--) *pm++=b;
 }
 void glmemmove(unsigned char huge *pm,unsigned char huge *p,long n) {
  while (n--) *pm++=*p++;
 }
#else
 #define HP
#endif

static int x0=0,y0=0,w=0,h=0,drwmode=PUTmode,druck=0;
static Pixel bcol;
static Pixel HP *pm,*pd=NULL;
static Windowst *frw,*frwsave,prfrw;
static Framest prfra;
const Pixel dmax=255;

/*fct drwframe */
Pixel * drwframe(Windowst *frwp) {
 Framest *frs=frwp->ptr;
 frw=frwp;
/* if (frw->typ!=W_FRAME) return 0;*/
 x0=frs->cx;
 y0=frs->cy;
 w =frs->cw;
 h =frs->ch;
 bcol=frw->col;
 if (frs->data) {
  if (frs->ndata==-1) pm=(Pixel *)frs->data;
  else      { h=w=-1; pm=NULL; }
 } else {
#ifdef B16
  if ((pm=(Pixel HP *)glmalloc((long)w*h*sizeof(Pixel)))==NULL)
#else
  if ((pm=(Pixel *)calloc(w*h,sizeof(Pixel)))==NULL)
#endif
  {
   x0=0,y0=0,w=0,h=0;
   return 0;
  }
  frs->data=pm; frs->ndata=-1;
  drwclear();
 }
 return pm;
}
/*fct drwzbuf */
void drwzbuf(void) {
 if (!w) return;
 if (pd)
#ifdef B16
  glfree(pd);
#else
  free(pd);
#endif

#ifdef B16
  pd=(Pixel HP *)glmalloc((long)w*h*sizeof(Pixel));
  glmemset(pd,dmax,(long)w*h);
#else
  pd=(Pixel *)calloc(w*h,sizeof(Pixel));
  memset(pd,dmax,w*h);
#endif
}
/*fct drwframename */
Pixel * drwframename(char *name) {
 Windowst *frw;
 frw=wfindname(NULL,name);
 if (frw) return drwframe(frw);
 else     return NULL;
}
/*fct drwclose */
void drwclose(Windowst *frwp) {
 Framest *frs=frwp->ptr;
/* if (frwp->typ!=W_FRAME) return 0;*/
 if (frw==frwp) pm=NULL,h=w=-1;
 if (frs->data && frs->ndata==-1) {
#ifdef B16
  glfree(frs->data);
#else
  free(frs->data);
#endif
  frs->data=NULL; frs->ndata=0;
 }
}
/*fct drwupdate */
void drwupdate(void) {
 if (pm) {
  if (druck) {
#ifdef MSW
   msw_printend(pm,w,h);
#endif
   drwclose(&prfrw);
   druck=0;
   if (frwsave!=NULL) drwframe(frwsave);
   frwsave=NULL;
  } else {
   w_wartsync(1);
   w_setcur(0);
   w_putbox(x0,y0,w,h,pm);
  }
 }
}
/*fct drwupdatew */
void drwupdatew(Windowst *frw) {
 Framest *frs=frw->ptr;
/* if (frwp->typ!=W_FRAME) return 0;*/
 if (frs->ndata==-1) {
  w_wartsync(1);
  w_setcur(0);
  w_putbox(frs->cx,frs->cy,frs->cw,frs->ch,(Pixel *)frs->data);
 }
}
/*fct drwsetmode */
int drwsetmode(int mode) {
 int m=drwmode;
 drwmode=mode;
 return m;
}
/*fct drwgetwh */
void drwgetwh(int *wp,int *hp) {
 *wp=w; *hp=h;
}
/*fct drwgetxy */
void drwgetxy(int *xp,int *yp) {
 *xp=x0; *yp=y0;
}
/*fct drwpixel */
int drwpixel(int x,int y,int col) {
 if (x>=w) return 0; else if (x<0) return 0;
 if (y>=h) return 0; else if (y<0) return 0;
 switch (drwmode) {
 case XORmode: pm[(long)y*w+x]^=col;   break;
 case SNZmode: if (col==SNZzero) break;
 case PUTmode: pm[(long)y*w+x]=col;
 }
 return 1;
}
/*fct drwhorlib */
static void drwhorlib(int y,int x1,int x2,int col) {
 int j;
 switch (drwmode) {
 case XORmode: for (j=x1;j<=x2;j++) pm[(long)y*w+j]^=col; break;
 case SNZmode: if (col==SNZzero) break;
 case PUTmode:
#ifdef B16
             glmemset(pm+(long)y*w+x1,col,x2-x1+1);
#else
               memset(pm+(long)y*w+x1,col,x2-x1+1);
#endif
 }
}
/*fct drwputzei */
static void drwputzei(int y,int x1,int x2,Pixel *p) {
 int j;
 switch (drwmode) {
 case XORmode: for (j=x1;j<=x2;j++) pm[(long)y*w+j]^=p[j-x1]; break;
 case SNZmode: for (j=x1;j<=x2;j++)
                if (p[j-x1]!=SNZzero) pm[(long)y*w+j]=p[j-x1];
               break;
 case PUTmode:
#ifdef B16
             glmemmove(pm+(long)y*w+x1,p,x2-x1+1);
#else
               memcpy(pm+(long)y*w+x1,p,x2-x1+1);
#endif
 }
}
/*fct drwgetzei */
static void drwgetzei(int y,int x1,int x2,Pixel *p) {
#ifdef B16
 glmemmove(p,pm+(long)y*w+x1,x2-x1+1);
#else
   memcpy(p,pm+(long)y*w+x1,x2-x1+1);
#endif
}
/*fct drwsetbox */
void drwsetbox(int xp,int yp,int wp,int hp,int col) {
 int x2=xp+wp-1,
     y2=yp+hp-1,i;
 if (xp>=w) return; else if (xp<0) xp=0;
 if (yp>=h) return; else if (yp<0) yp=0;
 if (x2<0 ) return; else if (x2>=w) { x2=w-1; if (x2<0) return; }
 if (y2<0 ) return; else if (y2>=h) y2=h-1;
 for (i=yp;i<=y2;i++) drwhorlib(i,xp,x2,col);
}
/*fct drwputbox */
void drwputbox(int xp,int yp,int wp,int hp,Pixel *pp) {
 Pixel HP *p=pp;
 int x1=xp,y1=yp,
     x2=xp+wp-1,
     y2=yp+hp-1,i;
 if (x1>=w) return; else if (x1<0) x1=0;
 if (y1>=h) return; else if (y1<0) y1=0;
 if (x2<0 ) return; else if (x2>=w) { x2=w-1; if (x2<0) return; }
 if (y2<0 ) return; else if (y2>=h) y2=h-1;
 p+=(yp-y1)*wp+(xp-x1);
 for (i=y1;i<=y2;i++) { drwputzei(i,x1,x2,p); p+=wp; }
}
/*fct drwgetbox */
void drwgetbox(int xp,int yp,int wp,int hp,Pixel *pp) {
 Pixel HP *p=pp;
 int x1=xp,y1=yp,
     x2=xp+wp-1,
     y2=yp+hp-1,i;
 if (x1>=w) return; else if (x1<0) x1=0;
 if (y1>=h) return; else if (y1<0) y1=0;
 if (x2<0 ) return; else if (x2>=w) { x2=w-1; if (x2<0) return; }
 if (y2<0 ) return; else if (y2>=h) y2=h-1;
 p+=(yp-y1)*wp+(xp-x1);
 for (i=y1;i<=y2;i++) { drwgetzei(i,x1,x2,p); p+=wp; }
}
/*fct drwclear */
void drwclear(void) {
/* drwsetbox(0,0,w,h,bcol);*/
#ifdef B16
 glmemset(pm,bcol,(long)w*h);
#else
 memset(pm,bcol,w*h);
#endif
}
#define ABS(a) (((a)<0) ? -(a) : (a))
/*fct drwlineb */
void drwlineb(int x1,int y1,int x2,int y2,int c) {
    int dx = x2 - x1;
    int dy = y2 - y1;
    int ax = ABS(dx) << 1;
    int ay = ABS(dy) << 1;
    int sx = (dx >= 0) ? 1 : -1;
    int sy = (dy >= 0) ? 1 : -1;
    int x  = x1;
    int y  = y1;
    int syw=sy*w;
    Pixel HP *p=pm+((long)y*w+x);
    if (ax > ay) {
        int d = ay - (ax >> 1);
        while (x != x2) {
            *p=c;
            if (d > 0 || (d == 0 && sx == 1)) {
                p+=syw;
                d -= ax;
            }
            x += sx; p+=sx;
            d += ay;
        }
    } else {
        int d = ax - (ay >> 1);
        while (y != y2) {
            *p=c;
            if (d > 0 || (d == 0 && sy == 1)) {
                p += sx;
                d -= ay;
            }
            y += sy; p+=syw;
            d += ax;
        }
    }
    *p=c;
}
/*fct drwlinec */
void drwlinec(int x1,int y1,int x2,int y2,int c) {
 if ((unsigned)x1<(unsigned)w && (unsigned)y1<(unsigned)h
  && (unsigned)x2<(unsigned)w && (unsigned)y2<(unsigned)h
  && drwmode==PUTmode) drwlineb(x1,y1,x2,y2,c);
 else {
    int dx = x2 - x1;
    int dy = y2 - y1;
    int ax = ABS(dx) << 1;
    int ay = ABS(dy) << 1;
    int sx = (dx >= 0) ? 1 : -1;
    int sy = (dy >= 0) ? 1 : -1;
    int x  = x1;
    int y  = y1;
    if (ax > ay) {
        int d = ay - (ax >> 1);
        while (x != x2) {
            drwpixel(x, y, c);
            if (d > 0 || (d == 0 && sx == 1)) {
                y += sy;
                d -= ax;
            }
            x += sx;
            d += ay;
        }
    } else {
        int d = ax - (ay >> 1);
        while (y != y2) {
            drwpixel(x, y, c);
            if (d > 0 || (d == 0 && sy == 1)) {
                x += sx;
                d -= ay;
            }
            y += sy;
            d += ax;
        }
    }
    drwpixel(x, y, c);
 }
}
/*fct drwlinelc */
void drwlinelc(int x1,int y1,int c1,int x2,int y2,int c2) {
    int dx = x2 - x1;
    int dy = y2 - y1;
    int ax = ABS(dx) << 1;
    int ay = ABS(dy) << 1;
    int sx = (dx >= 0) ? 1 : -1;
    int sy = (dy >= 0) ? 1 : -1;
    int x  = x1;
    int y  = y1;
    float c  = c1;
    int syw=sy*w;
    Pixel HP *p=pm+((long)y*w+x);
    if (ax > ay) {
        int d = ay - (ax >> 1);
        float dc= (float)(c2-c1)/(float)ABS(dx);
        while (x != x2) {
            *p=(Pixel)c;
            if (d > 0 || (d == 0 && sx == 1)) {
                p+=syw;
                d -= ax;
            }
            c+=dc;
            x += sx; p+=sx;
            d += ay;
        }
    } else {
        int d = ax - (ay >> 1);
        float dc= (float)(c2-c1)/(float)ABS(dy);
        while (y != y2) {
            *p=(Pixel)c;
            if (d > 0 || (d == 0 && sy == 1)) {
                p += sx;
                d -= ay;
            }
            c+=dc;
            y += sy; p+=syw;
            d += ax;
        }
    }
    *p=c2;
}

int drwfilledpol(int n,int x[],int y[],Pixel d[],Pixel c[]) {
 int xmi=x[0],ymi=y[0],xma=x[0],yma=y[0];
 int i,wp,hp,wsav=w;
 long wh;
 Pixel HP *p,*pz,*psav=pm;
 Pixel HP *dep=NULL;
 const Pixel nu=0,fi=1;
 for (i=1;i<n;i++) {
  int xi=x[i],yi=y[i];
  if      (xi<xmi) xmi=xi;
  else if (xi>xma) xma=xi;
  if      (yi<ymi) ymi=yi;
  else if (yi>yma) yma=yi;
 }
 ymi--;
 wp=xma-xmi+2;
 hp=yma-ymi+2;
 wh=(long)wp*hp;
 if (wh==0) return 0;
#ifdef B16
 if ((p=glmalloc(wh))==NULL) return -1;
 glmemset(p,nu,wh);
 if (d && pd) { if ((dep=glmalloc(wh))==NULL) return -1; }
#else
 if ((p=malloc(wh))==NULL) return -1;
 memset(p,nu,wh);
 if (d && pd) { if ((dep=malloc(wh))==NULL) return -1; }
#endif
 if (dep) {
  pm=dep; w=wp;
  for (i=1;i<n;i++)
   drwlinelc(x[i-1]-xmi,y[i-1]-ymi+1,d[i-1],x[i]-xmi,y[i]-ymi+1,d[i]);
   drwlinelc(x[n-1]-xmi,y[n-1]-ymi+1,d[n-1],x[0]-xmi,y[0]-ymi+1,d[0]);
 }
 pm=p; w=wp;
 for (i=1;i<n;i++)
  drwlinelc(x[i-1]-xmi,y[i-1]-ymi+1,c[i-1],x[i]-xmi,y[i]-ymi+1,c[i]);
  drwlinelc(x[n-1]-xmi,y[n-1]-ymi+1,c[n-1],x[0]-xmi,y[0]-ymi+1,c[0]);
 for (i=1;i<hp;i++) {
  int s,j=wp,st=0,uns=0;
  pz=p+((long)i*wp);
  while (j--) {
   if (*pz != nu) {
    st=!st;
    while (*(++pz) != nu) j--;
    s=*(pz-wp);
    if (s!=nu && s!=fi) {
     if (!uns) uns=j;
    } else {
     s=(s==fi);
     if (uns && s!=st) {
      Pixel HP *pn=pz;
      int n=uns-j;
      while (n--) {
       Pixel x=*(--pn);
       if      (x==fi) *pn=nu;
       else if (x==nu) *pn=fi;
      }
     }
     uns=0; st=s;
    }
   } else {
    if (uns) {
     Pixel u=*(pz-wp);
     if (u==fi||u==nu) {
      if ((u==fi)!=st) {
       Pixel HP *pn=pz;
       int n=uns-j;
       while (n--) {
        Pixel x=*(--pn);
        if      (x==fi) *pn=nu;
        else if (x==nu) *pn=fi;
       }
       st=u==fi;
      }
      uns=0;
     }
    }
    if (st) *pz=fi;
    pz++;
   }
  }
 }
 pm=psav; w=wsav;
 for (i=ymi<0?-ymi:1;i<hp&&i+ymi<h;i++) {
  int j,ja;
  Pixel HP *pa=NULL,*depz,
   *pmz=pm+((long)(i+ymi)*w),
   *pdz=pd+((long)(i+ymi)*w);
  pz=p+((long)i*wp);
  if (dep) depz=dep+((long)i*wp);
  for (j=0;j<wp;j++) {
   if (*pz != nu) {
    if (!pa) {
     ja=j,pa=pz;
    }
   } else if (pa) {
    float c1=(float)(*pa),
          c2=(float)(*(pz-1)),
          cd=(c2-c1)/(j-ja);
    int je=j;
    if (je+xmi>=w) je=w-1-xmi;
    if (dep) {
     float dd,d1;
     int id1=depz[ja];
     dd=(float)(depz[j-1]-id1)/(float)(j-ja);
     d1=id1;
     while (ja<je) {
      if (ja+xmi>=0) {
       if (id1<pdz[ja+xmi]) {
        pmz[ja+xmi]=c1;
        pdz[ja+xmi]=id1;
       }
      }
      c1+=cd; id1=(d1+=dd); ja++;
     }
    } else {
     while (ja<je) {
      if (ja+xmi>=0)
       pmz[ja+xmi]=c1;
      c1+=cd; ja++;
     }
    }
/*    drwlinelc(ja+xmi,i+ymi,*pa,j-1+xmi,i+ymi,*(pz-1)); */
    pa=NULL;
   }
   pz++;
  }
 }
#ifdef B16
 glfree(p);glfree(dep);
#else
 free(p);free(dep);
#endif
}

extern unsigned char font6x8[],font8x14[],__font8x8[];
static unsigned char *font_adress=NULL;
static int font_height=0,font_width=0,d_text_fg,d_text_bg,txtdrwmode;
/*fct drwfont */
int drwfont(int n,int color,int bcolor) {
 d_text_fg=color;
 if (bcolor==color) { d_text_bg=SNZzero; txtdrwmode=SNZmode; }
 else               { d_text_bg=bcolor;  txtdrwmode=PUTmode; }
 switch (n) {
 case 1: font_height=8; font_width=6; font_adress=font6x8;  break;
 case 2: font_height=8; font_width=8; font_adress=__font8x8;break;
 case 3: font_height=14;font_width=8; font_adress=font8x14; break;
 case 4: font_height=16;font_width=12;font_adress=font6x8;  break;
 case 5: font_height=28;font_width=16;font_adress=font8x14; break;
 }
 return font_width+(font_height<<5);
}
/*fct expandcharacter */
static void expandcharacter(char c,Pixel *bitmap ) {
 int x, y, b, mu=0, fw=font_width, fh=font_height;
 unsigned char *font,*font1;
 if (font_width>8) { mu=1; fw/=2; fh/=2; }
 font = font_adress + (((unsigned char)c)*fh);
 for (y = 0; y < font_height; y++) {
  if (mu) { if (y%2) font=font1; else font1=font; }
  for (x = 0; x < fw; x++) {
   if (x % 8 == 0)
    b = *font++;
   if (b & (128 >> (x % 8))) { /* pixel */
     *bitmap = d_text_fg;
     bitmap++;
     if (mu) *bitmap++ = d_text_fg;
   } else { /* background pixel */
     *bitmap = d_text_bg;
     bitmap++;
     if (mu) *bitmap++ = d_text_bg;
   }
  }
 }
}
/*fct writecompressed */
static void writecompressed( int x, int y,char *s ) {
 Pixel bitmap[448];
  while (*s != 0) {
   expandcharacter(*s++, bitmap);
   drwputbox(x , y, font_width, font_height, bitmap);
   x += font_width;
  }
}
/*fct drwtext */
void drwtext(int x,int y,char *s) {
 int svm=drwmode;
 drwmode=txtdrwmode;
 writecompressed(x,y,s);
 drwmode=svm;
}

/*fct drwprint */
void drwprint(int mode) {
 int m24= mode==0 ? 8 : 24 ;
 int i8,i,j;
 FILE *pfil=fopen("LPT1","wb");
 if (pfil==NULL) wcmessagexy(100,200,"fopen LPT1 failed!");
 if (pm==NULL || pfil==NULL) return;
 for (i8=0;i8<h;i8+=m24) {
  int b,bm,jb, je,je1;
  Pixel HP *p,*pz=pm+(i8*w);
  fputc(27,pfil);
  if (m24==24) { fputc('*',pfil);fputc(39,pfil); }
  else fputc('K',pfil);
  fputc(w%256,pfil); fputc(w/256,pfil);
  for (j=0;j<w;j++) {
   p=pz++;
   je= i8<h-m24 ? m24 : h-i8;
   for (jb=0;jb<(m24>>3);jb++) {
    b=0; bm=128; je1= je>8 ? 8 : je;
    for (i=0;i<je1;i++) {
     if (*p !=bcol) b+=bm;
     bm>>=1; p+=w;
    }
    je-=8;
    fputc(b,pfil);
   }
  }
  fputc(13,pfil);
  if (m24!=24) { fputc(27,pfil); fputc('J',pfil); fputc(24,pfil); }
  else         { fputc(27,pfil); fputc('J',pfil); fputc(24,pfil); }
 }
 fclose(pfil);
}

int drwprintini(double spixpmm,double *xpixpmm,double *ypixpmm) {
 int psxmm,psymm,psypx,psxpx,ier=0;
 if (w<=0) return ier;
 frwsave=frw;
#ifdef MSW
 ier=msw_printini(&psxmm,&psymm,&psxpx,&psypx);
#else

#endif
 if (ier>0) {
  *xpixpmm=psxpx/psxmm;
  *ypixpmm=psypx/psymm;
  prfra.cw=w* *xpixpmm / spixpmm+2;
  prfra.ch=h* *ypixpmm / spixpmm+2;
  prfra.cx=prfra.cy=0;
  prfra.data=NULL;
  prfrw.col=_BRIGHTWHITE;
  prfrw.ptr=&prfra;
  druck=1;
  drwframe(&prfrw);
  prfrw.x=psxpx,prfrw.y=psypx;
  drwlinec(0,0,prfra.cw-1,0,_BLACK);
  drwlinec(prfra.cw-1,0,prfra.cw-1,prfra.ch-1,_BLACK);
  drwlinec(prfra.cw-1,prfra.ch-1,0,prfra.ch-1,_BLACK);
  drwlinec(0,prfra.ch-1,0,0,_BLACK);
 }
 return ier;
}