#include <math.h>
#include <stdio.h>
#include <string.h>

#include "wirp.h"

static int lutsiz=0,nlut=16,r[256],g[256],b[256];
static char fileread[120]="\0";

static void opnfrm(void) {
 wcframe("drawing,20,16,260,132,white,frthin","",NULL);
}

static void drwlut(int setpal) {
 int i,j,mi,mj,x=0,y=0,w,h,ww,hh,c=16;
 drwgetwh(&ww,&hh);
 switch (lutsiz) {
 case 1: mi=1;mj=nlut;w=ww/mj;h=hh; break;
 case 2: mi=8;mj=8   ;w=ww/mj;h=hh/mi; break;
 case 3: mi=8;mj=16  ;w=ww/mj;h=hh/mi; break;
 case 4: mi=16;mj=16 ;w=ww/mj;h=hh/mi; break;
 default: return;
 }
 if (setpal)
  for (i=0;i<nlut;i++) w_setpal(c++,r[i],g[i],b[i]);
 c=16;
 drwframename("drawing");
 for (i=0;i<mi;i++) {
  x=0;
  for (j=0;j<mj;j++) {
   if (c-16>=nlut) break;
   drwsetbox(x,y,w,h,c++);
   x+=w;
  }
  y+=h;
 }
 drwupdate();
}

static double ergb,er,eg,eb;

static void editcb(char *sn,int ip1,int ip2) {
 int r,g,b;
 w_getpal((int)ergb+16,&r,&g,&b);
 er=r;eg=g;eb=b;
 wnsliderset("sre",er);
 wnsliderset("sge",eg);
 wnsliderset("sbe",eb);
}

static void edit1cb(char *sn,int ip1,int ip2) {
 w_setpal((int)ergb+16,(int)er,(int)eg,(int)eb);
 drwlut(0);
}

static void openedit(void) {
 int i;
 double slv1[]={0.0,255.0,1.0,0.0};
 double slv2[]={0.0,255.0,1.0,0.0};
 Windowst *sl;
 er=eg=eb=ergb=0;
 slv1[1]=nlut-1;
 wcframe( "fre,50,160,120,140,white,tlarge","Edit color",NULL);
 wcslider("sne,60,190,100,white,value,tlarge", slv1,&ergb,editcb);
 wcslider("sre,60,215,100,red,value,tlarge",  slv2,&er,edit1cb);
 wcslider("sge,60,240,100,green,value,tlarge",slv2,&eg,edit1cb);
 wcslider("sbe,60,265,100,blue,value,tlarge", slv2,&eb,edit1cb);
 editcb("",0,0);
}

static void helplbcb(char *n,int i,int j) {
 wnclose("helplibo");
}

static char *text[]= {
  "Use File,Open to read",
  " an existing lookuptable.",
  " ",
  " Lookuptable files consist of",
  " one line per color with ",
  "   index red green blue ",
  " where all values must be",
  " within 0..255. ",
  " ",
  "Use File,New to create",
  " a new lookuptable. ",
  " ",
  " Then select from the popup menu",
  " the size of the table, ",
  " possible values are",
  " 16, 64, 128, 236;",
  " the last not beeing 256",
  " to leave some background colors.",
  " Note that in SVGA cards the",
  " palette can only handle 6 bit ",
  " per color, so more than 64 values",
  " for a grey-lut is useless.",
  " ",
  " A default LUT with greyvalues",
  " is created and some sliders ",
  " allow editing. The LUT may be",
  " divided into sections (default 1) ",
  " and each section has a start and",
  " end rgbvalue, start may be  ",
  " higher than end.",
  " ",
  " After pressing Ok, single color",
  " entries may be changed.",
  " ",
  "Use File,Save to write",
  " the LUT to a file. ",
  " ",
  " CARE: there is no warning",
  " when overwriting a file!",
  " "};
static void mcbhelp1(char *menitem,int ip1,int ip2) {
 Windowst *lb;
 lb=wclistbox("helplibo,0,0,295,360,closemodal,white,tblack,tlarge",
              "", sizeof(text)/sizeof(char *),text,helplbcb);
 lb->mask|=MM_LMBUP;
}

static void mcbstop(char *menitem,int ip1,int ip2) {
  wcloseall();
}

static void mcbabout(char *menitem,int ip1,int ip2) {
  wcmessagexy(4,4,
  "  LookupTable Editor  \n"
  "Graphics library WIRP \n"
  "       A.Kstli       \n"
  " Stuttgart, 1996,1997 ");
}

static void mcbread(char *menitem,int ip1,int ip2) {
 char *f;
 wnclose("frs");
 wnclose("fre");
 wnclose("drawing");
 f=wfileselect(
  "Lookup (*.lut)|All (*.*)",
  ".",menitem);
 if (f && strcmp(f,"") ) {
  int i,m=0,l=0,cr,cg,cb;
  char ch[81];
  FILE *fi=fopen(f,"r");
  if (fi==NULL) {
   wcmessagexy(20,100,"Could not open file for reading!");
  } else {
   strcpy(fileread,f);
   for (i=0;i<256;i++) r[i]=g[i]=b[i]=0;
   while (!feof(fi)) {
    fgets(ch,80,fi);
    if (feof(fi)) break;
    l++;
    sscanf(ch,"%d %d %d %d",&i,&cr,&cg,&cb);
    if (i>=0 && i<256) {
     r[i]=cr; g[i]=cg; b[i]=cb;
     if (i>m) m=i;
    } else {
     sprintf(ch,"Error in %s at line %d",f,l);
     wcmessagexy(20,100,ch);
     break;
    }
   }
   fclose(fi);
   nlut=m+1;
   if (m>128)     lutsiz=4;
   else if (m>64) lutsiz=3;
   else if (m>16) lutsiz=2;
   else           lutsiz=1;
   opnfrm();
   drwlut(1);
   openedit();
  }
 }
}

static void mcbwrite(char *menitem,int ip1,int ip2) {
 FILE *fi;
 char *f;
 f=wfileselect(
  "Lookup (*.lut)|All (*.*)",
  ".",menitem);
 strcpy(fileread,f);
 if (strlen(fileread)) {
  int i,cr,cg,cb;
  fi=fopen(fileread,"w");
  if (fi==NULL) {
   wcmessagexy(20,100,"Could not open file for writing!");
  } else {
   for (i=0;i<nlut;i++) {
    w_getpal(i+16,&cr,&cg,&cb);
    fprintf(fi,"%d %d %d %d\n",i,cr,cg,cb);
   }
   fclose(fi);
  }
 }
}

static void mcbnew(char *menitem,int ip1,int ip2) ;

static void buttoncb(char *n,int ip1,int ip2) {
 wnclose("frs");
 openedit();
}

static double nrgbs=1,irgbs=1,r1,r3,g1,g3,b1,b3;
static double r1s[8],r3s[8],g1s[8],g3s[8],b1s[8],b3s[8];

static void slcb(char *ns,int ip1,int ip2) {
 int i,ia=0,is=0,nluts;
 i=irgbs;
 r1s[i-1]=r1; r3s[i-1]=r3;
 g1s[i-1]=g1; g3s[i-1]=g3;
 b1s[i-1]=b1; b3s[i-1]=b3;
 nluts=nlut/nrgbs;
 for (i=nlut;i<256;i++) r[i]=g[i]=b[i]=0;
 for (i=0;i<nlut;i++) {
  if (is<nrgbs-1 && i>=(is+1)*nluts) {
   is++; ia=i;
   if (is==nrgbs-1) nluts=nlut-nluts*is;
  }
  r[i]=r1s[is]+(r3s[is]-r1s[is])/(nluts-1)*(i-ia);
  g[i]=g1s[is]+(g3s[is]-g1s[is])/(nluts-1)*(i-ia);
  b[i]=b1s[is]+(b3s[is]-b1s[is])/(nluts-1)*(i-ia);
 }
 drwlut(1);
}

static void slscb(char *sn,int ip1,int ip2) {
 int i=irgbs;
 if (irgbs>nrgbs) {
  nrgbs=irgbs;
  r1s[i-1]=r1; r3s[i-1]=r3;
  g1s[i-1]=g1; g3s[i-1]=g3;
  b1s[i-1]=b1; b3s[i-1]=b3;
 } else {
  r1=r1s[i-1]; r3=r3s[i-1];
  g1=g1s[i-1]; g3=g3s[i-1];
  b1=b1s[i-1]; b3=b3s[i-1];
 }
 wnsliderset("sr1",r1);
 wnsliderset("sg1",g1);
 wnsliderset("sb1",b1);
 wnsliderset("sr3",r3);
 wnsliderset("sg3",g3);
 wnsliderset("sb3",b3);
 slcb("",0,0);
}

static void mcbform1(char *menitem,int ip1,int ip2) {
 int i;
 double slv1[]={0.0,15.0,1.0,0.0};
 double slvs[]={1.0, 8.0,1.0,0.0};
 Windowst *sl;
 switch(ip1) {
 case 1: lutsiz=1; nlut=16; break;
 case 2: lutsiz=2; nlut=64; break;
 case 3: lutsiz=3; nlut=128; break;
 case 4: lutsiz=4; nlut=236; break;
 }
 opnfrm();
 irgbs=nrgbs=1;
 r3=g3=b3=slv1[1]=255;
 r1=g1=b1=0;
 wcframe( "frs,010,160,280,220,white,tlarge,frthin",
                                     "Create Lookuptable",NULL);
 wclabel( "st1,110,186,80,black,tlarge","Section");
 wcslider("srs,110,200,80,white,value,tlarge",  slvs,&irgbs,slscb);
 wclabel( "st2,030,226,100,black,tlarge","Start color");
 wclabel( "st3,170,226,100,black,tlarge","End color");
 wcslider("sr1,030,240,100,red,value,tlarge",  slv1,&r1,slcb);
 wcslider("sr3,170,240,100,red,value,tlarge",  slv1,&r3,slcb);
 wcslider("sg1,030,270,100,green,value,tlarge",slv1,&g1,slcb);
 wcslider("sg3,170,270,100,green,value,tlarge",slv1,&g3,slcb);
 wcslider("sb1,030,300,100,blue,value,tlarge", slv1,&b1,slcb);
 wcslider("sb3,170,300,100,blue,value,tlarge", slv1,&b3,slcb);
 wcbutton("Ok,110,330,80,30,white,tlarge",NULL,NULL,buttoncb);
 slcb("",0,0);
}

static char *mefile="File ,New ,Open ,Save ,,Exit ";
static char *mehelp="Help ,Help ,,About ";
static char *meform="LUTcolors,  16,  64,  128,  236,";

static Wcallb mcbfile[] = {mcbnew,mcbread,mcbwrite,NULL,mcbstop };
static Wcallb mcbhelp[] = {mcbhelp1,NULL,mcbabout };
static Wcallb mcbform[] = {mcbform1,mcbform1,mcbform1,mcbform1,NULL };

static void mcbnew(char *menitem,int ip1,int ip2) {
 int i=1; char mc[100],*m;
 m=strcpy(mc,meform);
 while ((m=strchr(m,','))!=NULL && *(++m)!=0)
  if (i++==lutsiz) *m=Cmultiswon;
  else             *m=Cmultiswoff;
 wnclose("drawing");
 wnclose("frs");
 wnclose("fre");
 wcmenupopup(mc,mcbform);
}

int cmain(int argc,char **argv) {
 int i;
 wcframe("f0,0,0,300,400,cyan,noframe","",NULL);

 wcmenuadd(mefile,mcbfile);
 wcmenuadd(mehelp,mcbhelp);

 do {
  i=wloop();
  switch (i) {
  case 3 : /* CTRL-C */ wcloseall(); break;
  case 27: wnclose("helplibo"); wnclose("f_w_message");
  /* ESC */ wnclose("menuLUTcolors"); break;
  }
 } while (i);
}
