
#ifdef __cplusplus
extern "C" {
#endif

#ifndef VHAUPT
 #undef EXT
 #define EXT
#endif
#include "krn.h"

#define ET4_480      0x2e  /*  640x480x256    640=512+128    */
#define ET4_600      0x30  /*  800x600x256    800=512+256+32 */
#define ET4_768      0x38  /*  1024x768x256 */
#define VESA_480_8   0x101 /*  640x480x256  */
#define VESA_600_8   0x103 /*  800x600x256  */
#define VESA_768_8   0x105 /*  1024x768x256 */
#define VESA_1024_8  0x107 /*  1280x1024x256 1280=1024+256   */
#define VESA_480_24  0x112 /*  640x480x16M  */
#define VESA_600_24  0x115 /*  800x600x16M  */
#define VESA_768_24  0x118 /*  1024x768x16M */
#define VESA_1024_24 0x11b /*  1280x1024x16 */
/*
#define VGAMODE VESA_480_8
#if VGAMODE==ET4_480||VGAMODE==VESA_480_8
#define vga_mx 640
#define vga_my 480
#define vga_nb 1
#define    vga_linear(x,y)     ( (x)+((y)<<7)+((y)<<9) )
#endif
#if VGAMODE==ET4_600||VGAMODE==VESA_600_8
#define vga_mx 800
#define vga_my 600
#define vga_nb 1
#define    vga_linear(x,y)     ( (x)+((y)<<5)+((y)<<8)+((y)<<9) )
#endif
#if VGAMODE==ET4_768||VGAMODE==VESA_768_8
#define vga_mx 1024
#define vga_my 768
#define vga_nb 1
#define    vga_linear(x,y)     ( (x)+((y)<<10) )
#endif
#if VGAMODE==VESA_1024_8
#define vga_mx 1280
#define vga_my 1024
#define vga_nb 1
#define    vga_linear(x,y)     ( (x)+((y)<<10)+((y)<<8) )
#endif
#if VGAMODE==VESA_480_24
#define vga_mx 640
#define vga_my 480
#define vga_nb 3
#define    vga_linear(x,y)     ( ((x)+((y)<<7)+((y)<<9))*3 )
#endif
#if VGAMODE==VESA_600_24
#define vga_mx 800
#define vga_my 600
#define vga_nb 3
#define    vga_linear(x,y)     ( ((x)+((y)<<5)+((y)<<8)+((y)<<9))*3 )
#endif
#if VGAMODE==VESA_768_24
#define vga_mx 1024
#define vga_my 768
#define vga_nb 3
#define    vga_linear(x,y)     ( ((x)+((y)<<10))*3 )
#endif
#if VGAMODE==VESA_1024_24
#define vga_mx 1280
#define vga_my 1024
#define vga_nb 3
#define    vga_linear(x,y)     ( ((x)+((y)<<10)+((y)<<8))*3 )
#endif
*/
#define vga_linear(x,y) ( vga_my==480 ? ( (x)+((y)<<7)+((y)<<9) ) :\
                          vga_my==600 ? ( (x)+((y)<<5)+((y)<<8)+((y)<<9) ) :\
                          vga_my==768 ? ( (x)+((y)<<10) ) :\
                                        ( (x)+((y)<<10)+((y)<<8) ) )

EXT unsigned int
 vga_mx
#ifdef VHAUPT
 =640
#endif
 ,vga_my
#ifdef VHAUPT
 =480
#endif
 ,vga_nb
#ifdef VHAUPT
 =1
#endif
 ;
 
typedef unsigned char Pixel;
enum { Cswitchon='',Cswitchoff='',Cmultiswoff='',Cmultiswon='',
       Cinactive= '' };
enum {PUTmode=0,XORmode,SNZmode};
#define SNZzero 255
EXT long vga_rgb[]
#ifdef VHAUPT
  ={0x000000L, 0x2a0000L, 0x002a00L, 0x2a2a00L, 0x00002aL, 0x2a002aL,
    0x002a2aL, 0x2a2a2aL, 0x303030L, 0x3F1515L, 0x153f15L, 0x3f3f15L,
    0x15153fL, 0x3f153fL, 0x153f3fL, 0x3f3f3fL}
#endif
                                ;
enum {vga_smallfont=1,vga_6x8font=1,vga_8x8font=2,vga_8x14font=3};
EXT int text_fg,text_bg,DRWmode,TXTDRWmode;
EXT unsigned int xclip0,yclip0,xclip1,yclip1,xclipa,yclipa;
EXT int vga_cursor;

#define w_mx vga_mx
#define w_my vga_my
#define w_mediofont vga_8x8font
#define w_smallfont vga_6x8font
#define w_largefont vga_8x14font
#define w_setmode vga_setmode
#define w_getmode vga_getmode
#define w_setcur vga_setcur
#define w_setclip(on)
#define w_init vga_init
#define w_enit vga_enit
#define w_selectcur vga_selectcur
#define w_drawpixel(x,y,c) vga_drawpixel((x)-xclip0,(y)-yclip0+yvermenu,(c))
#define w_readpixel(x,y,c) vga_readpixel((x)-xclip0,(y)-yclip0+yvermenu,(c))
#define w_putbox(x,y,w,h,p) vga_putbox((x)-xclip0,(y)-yclip0+yvermenu,(w),(h),(p))
#define w_getbox(x,y,w,h,p) vga_getbox((x)-xclip0,(y)-yclip0+yvermenu,(w),(h),(p))
#define w_rect(x,y,u,v,p) vga_rect((x)-xclip0,(y)-yclip0+yvermenu,(u)-xclip0,(v)-yclip0+yvermenu,(p))
#define w_fillrect(x,y,u,v,p) vga_fillrect((x)-xclip0,(y)-yclip0+yvermenu,(u)-xclip0,(v)-yclip0+yvermenu,(p))
#define w_horli(y,x,v,p) vga_horli((y)-yclip0+yvermenu,(x)-xclip0,(v)-xclip0,(p))
#define w_drawline(x,y,u,v,p) vga_drawline((x)-xclip0,(y)-yclip0+yvermenu,(u)-xclip0,(v)-yclip0+yvermenu,(p))
#define w_font vga_font
#define w_text(x,y,s) vga_text((x)-xclip0,(y)-yclip0+yvermenu,(s))
#define w_getmes vga_getmes
#define w_wartsync vga_wartsync
#define w_getpal vga_getpal
#define w_setpal vga_setpal

#define vga_setmode(m)   DRWmode=(m);
#define vga_getmode()    DRWmode
#define vga_setcur(on)   if (vga_cursor!=(on)){vga_cursor=(on);vga_drwcur();}
void vga_init(void);
void vga_enit(void);
void vga_selectcur(int n) ;
void vga_drawpixel(unsigned int x,unsigned int y,Pixel c) ;
Pixel vga_readpixel(unsigned int x,unsigned int y) ;
void vga_putzei(int y,int x,int n,Pixel *c) ;
void vga_getzei(int y,int x,int n,Pixel *c) ;
void vga_putbox(int x,int y,int w,int h,Pixel *pix) ;
void vga_getbox(int x,int y,int w,int h,Pixel *pix) ;
void vga_alleszu(Pixel c) ;
void vga_rect(int x1,int y1,int x2,int y2,int f) ;
void vga_fillrect(int x1,int y1,int x2,int y2,int f) ;
void vga_horli(int y,int x1,int x2,Pixel c) ;
void vga_drawline(int x1, int y1, int x2, int y2,Pixel c) ;
void vga_drawlinb(int x1, int y1, int x2, int y2,Pixel c) ;
int vga_font(int n,int color,int bcolor) ;
void vga_text(int x,int y,char *s) ;
void vga_drwcur(void) ;
int vga_getmes(Evstack *ev,int warte) ;
void vga_wartsync(int n);
void vga_setpal(int ix,int red,int green,int blue) ;
void vga_getpal(int ix,int *red,int *green,int *blue) ;
void vga_setallpal(unsigned char *rgb) ;
void vga_getallpal(unsigned char *rgb) ;
#ifdef __cplusplus
};
#endif
