/* ToDo:
  getbox errorcode,
  timer (slider)
 */
        
#include "xwi.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
/* #include <X11/Xos.h> wg.interact */
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>

#include <stdio.h>
#include <stdlib.h>


#define Nfarb 15
#define Npal 144

static char *winname = {"WIRP"};
static Display *display;
static int screennum;
static Window win;
static Drawable drw,pixm[4];
static unsigned int xmap[4]={0,0,0,0},ymap[4];
static unsigned int displayhg,winw,winh,winx=0,winy=0,winb=2,maxcol;
static int weiss,schwarz;
static int xclipred,yclipred;
static XEvent event;
static XGCValues values;
static GC gc,gcx;
static Cursor curzei,curmen,curwei;
static Colormap colmap;
static unsigned long colpix[256],colpixr[256];
static unsigned char pixr[256],pixg[256],pixb[256];
static int palwri=1,nbp=0,defdep=0;

/*fct xwi_rgbq*/
void xwi_rgbq(long rgb,XColor *xc) {
 xc->red=  (rgb&0xff)<<8;
 xc->green=((rgb>>8)&0xff)<<8;
 xc->blue =((rgb>>16)&0xff)<<8;
 xc->flags=DoRed|DoGreen|DoBlue;
}

/*fct xwi_init*/
void xwi_init(void)
{
 char *disname=NULL;
 int pmw=32,pmh=32,pm[32],i;
 if ((display=XOpenDisplay(disname))==NULL) {
  fprintf(stderr,"cannot connect to server %s\n",XDisplayName(disname));
  exit(-1);
 }
 screennum=DefaultScreen(display);
 displayhg=DisplayHeight(display,screennum);
 defdep=DefaultDepth(display,screennum);
 schwarz= BlackPixel(display,screennum);
 weiss=   WhitePixel(display,screennum);
 curmen=XCreateFontCursor(display,XC_arrow);
 curzei=XCreateFontCursor(display,XC_crosshair);
 curwei=XCreateFontCursor(display,XC_crosshair);
 {
  XColor colw,cols,colexact;
  colmap=DefaultColormap(display,screennum);
   if (XLookupColor(display,colmap,"black",&colexact,&cols)
    && XLookupColor(display,colmap,"yellow",&colexact,&colw))
      XRecolorCursor(display,curwei,&colw,&cols);
 }
 winw=60,winh=40;
 win=XCreateSimpleWindow(display,RootWindow(display,screennum),winx,winy,winw,
                         winh,winb,schwarz,weiss);
 XStoreName(display,win,winname);

 drw=win; 
 XSelectInput(display,win,ExposureMask|KeyPressMask|ButtonPressMask|
                          ButtonReleaseMask| /* PointerMotionHintMask| */
                          PointerMotionMask|
                          StructureNotifyMask);

 if (defdep<4) { printf("16 Color Server minimum required!\n"); exit(1); }
 else {
  XColor colexact;
  unsigned long plmask[1];
  if (defdep==24) nbp=3;
  if (defdep==16||defdep==15) nbp=2;
  if (defdep==8)  nbp=1;
  if (nbp==0) { printf("Display depth 8, 15, 16 or 24 required!\n"); exit(1); }
  colmap=DefaultColormap(display,screennum);
  if (!XAllocColorCells(display,colmap,False,plmask,0,colpix,Npal))
            /*   { printf("80 Color Cells required!\n"); exit(1); } */
   palwri=0;
  for (i=0;i<16;i++) {
   xwi_rgbq(xwi_rgb[i],&colexact);
   if (palwri) {
    colexact.pixel=colpix[i];
    XStoreColor(display,colmap,&colexact);
   } else {
    XAllocColor(display,colmap,&colexact);
    colpix[i]=colexact.pixel;
   }
   pixr[i]=colexact.red;
   pixg[i]=colexact.green;
   pixb[i]=colexact.blue;
  }
  maxcol=16;
  if (defdep>6) {
   maxcol=Npal;
   for (i=16;i<Npal;i++) {
    int c=(i-16)<<1;
    xwi_rgbq((((long)c)<<16)+(c<<8)+c,&colexact);
    if (palwri) {
     colexact.pixel=colpix[i];
     XStoreColor(display,colmap,&colexact);
    } else {
     XAllocColor(display,colmap,&colexact);
     colpix[i]=colexact.pixel;
    }
    pixr[i]=colexact.red;
    pixg[i]=colexact.green;
    pixb[i]=colexact.blue;
   }
  }
  for (i=0;i<256;i++) colpixr[i]=colpix[0];
  for (i=0;i<Npal;i++) colpixr[colpix[i]%256]=i;
 }

 gc =XCreateGC(display,win,0,NULL);
 gcx=XCreateGC(display,win,0,NULL);
 XSetForeground(display,gc,schwarz); 
 XSetBackground(display,gc,weiss); 
 XSetForeground(display,gcx,weiss^schwarz); 
 XSetFunction  (display,gcx,GXxor);

 XMapWindow(display,win);
// XSetInputFocus(display, win, RevertToPointerRoot, CurrentTime);

 xwi_mx= winw;
 xwi_my= winh;

}


/*fct xwi_movewin*/
void xwi_movewin(int x,int y,int w,int h) {
 XSizeHints H;
 XMoveResizeWindow(display,win,x,y,w,h);
 H.x=x,H.y=y;
 H.width=H.min_width=H.max_width=w;
 H.height=H.min_height=H.max_height=h;
 H.flags=PMinSize+PMaxSize;
 XSetWMNormalHints(display,win,&H);
 XRaiseWindow(display,win);
 xwi_mx=w, xwi_my=h;
 xwi_wartsync(1);
}
/*fct xwi_visibil*/
int xwi_visibil(void) {
 return 0;
}
/*fct xwi_selectcur*/
void xwi_selectcur(int n) {
 static int nl=-1;
 if (n!=nl) {
  nl=n;
  if (!n) {
    XDefineCursor(display,win,curwei);
   /*XDefineCursor(display,win,curzei);*/
  }
  else XDefineCursor(display,win,curmen);
 }
}

/*fct xwi_getmes*/
int xwi_getmes(Evstack *ev,int warte) {
 static int xl,yl,but;
 int kp,i,nbuf=4,ch;
 char buf[3];
 KeySym keysym;
 XComposeStatus compose;
 kp=0;
 if (warte || XEventsQueued(display,QueuedAlready)!=0) {
  XNextEvent(display,&event);
  switch(event.type) {
  case Expose:
   if (event.xexpose.count!=0) break;
   kp=paint_mask;
   break;
  case ConfigureNotify:
   winw=event.xconfigure.width;
   winh=event.xconfigure.height;
   xwi_mx= winw;
   xwi_my= winh;
   kp=size_mask;
   break;
  case ButtonPress:
     xl=event.xbutton.x;
     yl=event.xbutton.y;
     switch (event.xbutton.button) {
     case 1: kp=MM_LMBDOWN;but|=LMB_DOWN;break;
     case 2: kp=MM_MMBDOWN;but|=MMB_DOWN;break;
     case 3: kp=MM_RMBDOWN;but|=RMB_DOWN;break;
     }
     if (event.xbutton.state & ControlMask) but|=KEY_CTRL;else but&=~KEY_CTRL;
     if (event.xbutton.state & ShiftMask)   but|=KEY_LSH; else but&=~KEY_LSH;
   /*
   { char cha[40];
     sprintf(cha,"%d %d %d",xl,yl,kp);
     XDrawImageString(display,win,gc[0],winx+winw-98 ,winy+winh-1 ,cha,strlen(cha));
     XDrawRectangle  (display,win,gc[0],winx+winw-100,winy+winh-11,100,10);
   }
   */
   break;   
  case ButtonRelease:
   xl=event.xbutton.x;
   yl=event.xbutton.y;
   switch (event.xbutton.button) {
   case 1: kp=MM_LMBUP;but^=LMB_DOWN;break;
   case 2: kp=MM_MMBUP;but^=MMB_DOWN;break;
   case 3: kp=MM_RMBUP;but^=RMB_DOWN;break;
   }
   break;
  case MotionNotify:
   while(XCheckMaskEvent(display,PointerMotionMask,&event));
   /* if (!XQueryPointer(display,event.xmotion.window,&win,&win,&i,&i,
                      &xl,&xl,&kp)) break; */
   xl=event.xmotion.x;
   yl=event.xmotion.y;
   kp=MM_MOVE;
   break;
  case KeyPress:
   i=XLookupString(&event.xkey,buf,nbuf,&keysym,&compose);
   if      (keysym==XK_Return)    ch='\n';
   else if (keysym==XK_BackSpace) ch='\b';
   else if (keysym==XK_Left)      ch=key_left;
   else if (keysym==XK_Right)     ch=key_right;
   else if (keysym==XK_Up)        ch=key_up  ;
   else if (keysym==XK_Down)      ch=key_down;
   else if (keysym==XK_Home)      ch=key_home;
   else if (keysym==XK_End )      ch=key_end ;
   else if (keysym==XK_Prior)     ch=key_pgup;
   else if (keysym==XK_Next)      ch=key_pgdn;
   else if (keysym<=XK_asciitilde)ch=buf[0];
   kp=key_mask;
   if (event.xkey.state & ControlMask) but|=KEY_CTRL;else but&=~KEY_CTRL;
   if (event.xkey.state & ShiftMask)   but|=KEY_LSH; else but&=~KEY_LSH;
   break;
  default:
   break;
  }
 }
 ev->x=xl; ev->y=yl; ev->mask=kp; ev->buttn=but;
 if (kp==key_mask) return ch;
 else return -kp;
}

/*fct xwi_enit*/
void xwi_enit(void) {
 int i;
/* XFreeGC(display,gcx);
   XFreeGC(display,gc);*/
   XCloseDisplay(display);
}

/*fct xwi_drawline*/
void xwi_drawline(int x,int y,int x1,int y1,Pixel f) {
 if (DRWmode==XORmode)
  XDrawLine(display,drw,gcx  ,x,y,x1,y1);
 else {
  XSetForeground(display,gc,colpix[f]);
  XDrawLine(display,drw,gc,x,y,x1,y1); 
 }
}
/*fct xwi_horli*/
void xwi_horli(int y,int x1,int x2,Pixel c) { xwi_drawline(x1,y,x2,y,c); }
/*fct xwi_fillrect*/
void xwi_fillrect(int x,int y,int x1,int y1,int f) {
 XSetForeground(display,gc,colpix[f]);
 XFillRectangle(display,drw,gc,x,y,abs(x1-x)+1,abs(y1-y)+1);
}
/*fct xwi_rect*/
void xwi_rect(int x1,int y1,int x2,int y2,int f) {
 if (DRWmode==XORmode)
  XDrawRectangle(display,drw,gcx,x1,y1,x2-x1+1,y2-y1+1);
 else {
  XSetForeground(display,gc,colpix[f]);
  XDrawRectangle(display,drw,gc ,x1,y1,x2-x1+1,y2-y1+1);
 }
}
/*fct xwi_drawpixel*/
void xwi_drawpixel(unsigned int x,unsigned int y,Pixel c) {
 XSetForeground(display,gc,colpix[c]);
 XDrawPoint(display,drw,gc,x,y);
}
/*fct xwi_readpixel
Pixel xwi_readpixel(unsigned int x,unsigned int y) {
}*/

/*
void pixmap(int bild,int xm,int ym)
{
 drw=XCreatePixmap(display,win,xm,ym,DefaultDepth(display,screennum));
 xmap[bild]=xm;
 ymap[bild]=ym;
}
void copymap(int bild,int x0,int y0)
{
 unsigned int xm,ym;
 xm=xmap[bild];
 ym=ymap[bild];
 XCopyArea(display,drw,win,gc,0,0,xm,ym,x0,y0);
 XFreePixmap(display,drw);
 drw=win;
}
void fensterchen(int x0,int y0,int xa,int ya)
{
 XRectangle xr;
 xr.x=0;
 xr.y=0;
 xr.width=xa;
 xr.height=ya;
 XSetClipRectangles(display,gcx,x0,y0,&xr,1,Unsorted);
 XSetClipRectangles(display,gc[typfarb[12]],x0,y0,&xr,1,Unsorted);
 if (typfarb[12]!=typfarb[13])
 XSetClipRectangles(display,gc[typfarb[13]],x0,y0,&xr,1,Unsorted);
 xclipred=x0;
 yclipred=y0;
}*/
/*fct xwi_setclip*/
void xwi_setclip(int on) {
 XRectangle xr;
 if (on) {
  xr.x=0;
  xr.y=0;
  xr.width=xclipa;
  xr.height=yclipa;
  XSetClipRectangles(display,gc ,xclip0,yclip0,&xr,1,Unsorted);
  XSetClipRectangles(display,gcx,xclip0,yclip0,&xr,1,Unsorted);
 } else {
  XSetClipMask(display,gc ,None);
  XSetClipMask(display,gcx,None);
 }
}
/*fct xwi_wartsync*/
void xwi_wartsync(int n) {
 XFlush(display);
}

/*fct xwi_putbox*/
void xwi_putbox(int x,int y,int w,int h,Pixel *pix) {
 XImage *image;
 char *p;
 int i;
 if ((p=malloc(w*h*nbp))==NULL) return;
 image=XCreateImage(display,DefaultVisual(display,screennum),defdep,ZPixmap,0,
                    p,w,h,8,0);
 if (nbp==1) {
  for (i=0;i<w*h;i++) *p++=colpix[*pix++];
 } else if (nbp==2) {
  short *s=(short *)p;
  for (i=0;i<w*h;i++)  *s++=colpix[*pix++];
 } else if (nbp==3) {
  for (i=0;i<w*h;i++) { 
   int u=*pix++;
   *p++=pixb[u]; *p++=pixg[u]; *p++=pixr[u];
   /* rgb sequence machine dependant?                      */
   /* if colors incorrect, try to replace above line with: */
   /* *p++=pixr[u]; *p++=pixg[u]; *p++=pixb[u]; */
  }
 }
 XPutImage(display,win,gc,image,0,0,x,y,w,h);
 XDestroyImage(image);
}
/*fct xwi_getbox*/
void xwi_getbox(int x,int y,int w,int h,Pixel *pix) {
 XImage *image;
 unsigned char *p;
 int i,j,im;
return;
 image=XGetImage(display,win,x,y,w,h,0xff,ZPixmap);
 p=(unsigned char *)image->data;
 switch (image->bitmap_pad) {
 case 16: im=w%2; break;
 case 32: im=w%4; if (im) im=4-im; break;
 }
 for (i=0;i<h;i++) {
  for (j=0;j<w;j++) *pix++=colpixr[*p++];
  p+=im;
 }
 XDestroyImage(image);
}

#include "font6x8.c"
#include "font8x8.c"
#include "font8x14.c"
static unsigned char *font_adress=NULL;
static int font_height=0,font_width=0;
/*fct xwi_font*/
int xwi_font(int n,int color,int bcolor) {
 text_fg=color;
 if (bcolor==color) { text_bg=SNZzero; TXTDRWmode=SNZmode; }
 else               { text_bg=bcolor;  TXTDRWmode=PUTmode; }
 switch (n) {
 case 1: font_height=8; font_width=6;font_adress=font6x8;  break;
 case 2: font_height=8; font_width=8;font_adress=__font8x8;break;
 case 3: font_height=14;font_width=8;font_adress=font8x14; break;
 }
 return font_width+(font_height<<5);
}
/*fct expandcharacter*/
static void expandcharacter(char c,Pixel *bitmap ) {
 int x, y, b;
 unsigned char *font;
 font = font_adress + (((unsigned char)c)*font_height);
/* Geht nur, solange width<=8 und wenn bei width<8 jedes Zeichen auf Bytegrenze*/
 for (y = 0; y < font_height; y++) {
  for (x = 0; x < font_width; x++) {
   if (x % 8 == 0)
    b = *font++;
   if (b & (128 >> (x % 8))) { /* pixel */
     *bitmap = text_fg;
     bitmap++;
   } else { /* background pixel */
     *bitmap = text_bg;
     bitmap++;
   }
  }
 }
}
/*fct writecompressed*/
static void writecompressed( int x, int y,char *s ) {
 Pixel bitmap[112],*bz=NULL,*p,*p1;
 int n=strlen(s);
 int i,j,nc=0;
 if (DRWmode!=SNZmode) bz=malloc(n*font_height*font_width*sizeof(Pixel));
  while (*s != 0) {
   expandcharacter(*s++, bitmap);
   if (DRWmode==SNZmode) {
    p=bitmap;
    for (i=y;i<y+font_height;i++)
     for (j=x;j<x+font_width;j++)
      if (*p++ == text_fg) xwi_drawpixel(j,i,text_fg);
    x += font_width;
   } else {
    if (bz) {
     p1=bitmap;
     for (i=0;i<font_height;i++) {
      p=bz+(i*n+nc)*font_width;
      for (j=0;j<font_width;j++) *p++=*p1++;
     }
     nc++;
    } else {
     xwi_putbox(x , y, font_width, font_height, bitmap);
     x += font_width;
    }
   }
  }
  if (bz) {
   xwi_putbox(x , y, font_width*n, font_height, bz);
   free(bz);
  }
}
/*fct xwi_text*/
void xwi_text(int x,int y,char *s) {
 int svm=DRWmode;
 DRWmode=TXTDRWmode;
 writecompressed(x,y,s);
 DRWmode=svm;
}

void xwi_setpal(int ix,int red,int green,int blue) {
 XColor xc;
 xc.pixel=colpix[ix];
 xc.red=  red<<8;
 xc.green=green<<8;
 xc.blue =blue<<8;
 xc.flags=DoRed|DoGreen|DoBlue;
 if (palwri) {
  XStoreColor(display,colmap,&xc);
 } else {
  XAllocColor(display,colmap,&xc);
  colpix[ix]=xc.pixel;
 }
 colpixr[colpix[ix]%256]=ix;
 pixr[ix]=xc.red;
 pixg[ix]=xc.green;
 pixb[ix]=xc.blue;
}
void xwi_getpal(int ix,int *red,int *green,int *blue) {
 XColor xc;
 xc.pixel=colpix[ix];
 xc.flags=DoRed|DoGreen|DoBlue;
 XQueryColor(display,colmap,&xc);
 *red=  xc.red>>8;
 *green=xc.green>>8;
 *blue =xc.blue>>8;
}
/*
void xwi_setallpal(unsigned char *rgb) ;
void xwi_getallpal(unsigned char *rgb) ;
*/
